#!
# (c) napp-it  2017
# 16.nov 2017X11SPH-nCTPF

# job for reports

# debug: run from console
# perl /var/web-gui/data/napp-it/zfsos/_lib/scripts/job-report.pl run_123 456
# 123= jobid, 456=time()

# july 2016, use fqdn as hostname
# 27, jan 2023, log smtp result, webapi

use strict;
use Fcntl qw(:flock);                                          # filelocking
$|=1;                                                          # keine Pufferung, no buffering

use vars qw($wpath $dpath $tpath $par $id $action $os $f $t @t $p @p @reports $reports @run %sys %cfg %current $error $alert $alertlist $reasons $info $message $text $subject $smtp $ref $path);

$wpath="/xampp/web-gui";
$dpath="/xampp/web-gui/data";
$tpath="/xampp/web-gui/tmp";

use lib "/xampp/web-gui/data/cs_server/CGI";

require "$wpath/_lib/windows/scripts/task-lib.pl";        #
require "$wpath/data/wwwroot/cgi-bin/admin-wlib.pl";
require "$wpath/_lib/$os/zfslib.pl";

$par=$ARGV[0];
 if (!(defined($par))) {
     &my_log("job-report:  missing parameter");
      exit;
 }

 ############

 #par: action_job timestamp
 $par=~s/ .*//;

 # parameter: action_$job time
 if (!($par =~/\w+\_\d+$/)) {
     print "job-report 45: wrong par $par";
     exit;
 }
 @t=();
 @t=split(/\_/,$par);    # action job
 $action=$t[0];
 $action=~s/[^a-z]//g;

 $id=$t[1];
 #############################################

 # get par -> %current
 &task_read_jobpar($id);

 #reports to run ex r01, r02
 $t=$id."_trigger";
 $t=$current{$t};
 $t=~s/ //g;     # remove spaces
 @reports=split(/,/,$t);

 #debug
 # &print_var($t);
 # &print_array(@run);
 # &print_hash(%current);

 # run?
 if ($action eq "")                     {  print "job-other 42: wrong action - must be not empty\n";      exit; }
 if (!("run,cancel,delete"=~/$action/)) {  print "job-other 43: wrong action - must be run: $action \n";  exit; }

 #cancel or delete
 if ($action eq "cancel") { &my_cancel; $info="cancel job";  &my_log; exit; }
 if ($action eq "delete") { &my_delete; $info="delete job";  exit; }


 # read reports with path
    &my_reports;

 #debug
     #&print_array(@reports);

 # run
    $error=&my_run;        # alerts and status
    &my_log;
    exit;
########################### end of main

##############
sub my_reports {
############## active reports with path
    #  read common scripts
    @t=();
    my @r=();
    my $r;

    &read_dir('/var/web-gui/data/napp-it/zfsos/_lib/scripts/report/','t','\.pl$');

    #add path
    foreach my $t (@t) {
      $t="/var/web-gui/data/napp-it/zfsos/_lib/scripts/report/$t";
    }
    push (@r,@t);

    # read my scripts
    @t=();
    &read_dir('/var/web-gui/_my/zfsos/_lib/scripts/report/','t','\.pl$');

    #add path
    foreach my $t (@t) {
      $t="/var/web-gui/_my/zfsos/_lib/scripts/report/$t";
    }
    push (@r,@t);

    ## push active reports to @run
    foreach my $r (@r) {                    # all available reports with path
          foreach my $report (@reports) {   # selected in job ex r01
             if ($r=~/\/$report\#/) {
                push (@run,$r);             # all reports to process
             }
          }
    }
    @run=sort(@run);

    #debug
    # &print_array(@r);   exit;
    # &print_hash(%cfg);

    # alerts are send only once per day
    # delete all sendlogfiles > 1
    @t=();
    &read_dir('/var/web-gui/_log/report/alert.reported/','t','\.log$');
    foreach my $t (@t) {
      $r=(-M "/var/web-gui/_log/report/alert.reported/$t");
      if ($r > 1) {    # older 1 day
          print "remove old sendlog $t";
          `rm /var/web-gui/_log/report/alert.reported/$t`;
      }
    }
}

 ## delete job
 sub my_delete {
 ##############
 my ($r);
      if ($id ne "") {
        $r=`sudo rm -f /var/web-gui/_log/jobs/$id.*`;
        print "##### job-72: delete $id ######  $r\n";
      } else {
        print "job-74 delete, no id !! ########### \n";
      }
 }

############ update jobpar
sub my_last {
###########
  # update .par
  &task_gettime;                                             # $current{'timestamp'}, $current{'logtime'}
  $t="$id"."_last";                                          # update last
  $current{$t}=$current{'logtime'};
  &task_update_par($id);
}


#############
 sub my_run {
 ############
  my ($r,$todo,$run);
  &getdate;                                #  adminlib

  #debug
  # &print_hash(%current);

  $t=$id."_text1";
  $todo=$current{$t};

  #run all reports
  my $host=`hostname`;
  chomp($host);


  foreach $run (@run) {

     $r="";

     #for this os?
     if ($os eq 'linux') {
        if (!($run=~/L/)) {
           print "## not for Linux: $run";
           next;
        }
     }
     if ($os eq 'illumos') {
        if (!($run=~/I|S/)) {
           print "## not for Illumos/Solaris: $run";
           next;
        }
     }

     ##r05: smart optional with now when status is processed
     if (($todo=~/status/i) && ($run=~/smart/i)) {
         print "perl $run now\n";
         $r=`/usr/bin/perl $run now`
     } else {
         print "perl $run\n";
         $r=`/usr/bin/perl $run`;
     }

     if ($r=~/skip: /s)           {  next; }        # skip report
     if (!($r=~/message_begin/s)) {  next; }        # skip report

     # use nl
     $r=~s/<br>/\n/gs;
     print "$r\n\n";

     #process alert and is this an alert
     if ($todo =~/alert/i) {

         #alert allowed?
         if (!($run=~/A/)) {
                print "## no Alert in $run";
                next;
         }

         if (!($r=~/message_begin=ok/s)) {

              #alertlist (multiple error reasons ex jobs)
              if ($r=~/alertlist_begin=/s) {
                 $t=$r;
                 $t=~s/.*alertlist_begin=//s;
                 $t=~s/alertlist_end.*//s;
                 $alertlist.="$t,";
              }

              # alertmess
              if ($alert eq "") {
                   $alert= "Alert/ Error on $host from $sys{'date_and_time'}\n";
              }

              # get reason
              $t=$r;
              $t=~s/.*message_begin=//s;
              $t=~s/message_end.*//s;

              if ($reasons eq "") {
                 $reasons="Storage alert: ";
              }
              $reasons.="$t, ";            # add current alert reason
              $alert.="\n";               # Alertmessage header

              #get alert message
              $t=$r;
              $t=~s/.*alert_begin=//s;
              $t=~s/alert_end.*//s;
              $alert.="$t\n\n";
         }

     }

     #process status?
     if ($todo =~/status/i) {

         #status allowed?
         if (!($run=~/S/)) {
                print "## no Status in $run";
                next;
         }

         if ($r=~/status_begin=/s) {

              $t=$run; $t=~s/.*\///;
              $text.="\n#######\nReport: $t \n#######\n";         # add current report

              #get status message
              $t=$r;
              $t=~s/.*status_begin=//s;
              $t=~s/status_end.*//s;
              $text.="$t\n\n";
         }
     }
  }

  $reasons=~s/, $//s;
  $alertlist=~s/,$//s;

  #debug
  #print "###\nreports=$reports \n###";
  #&print_hash(%current);

  print <<EoF;
########################################################################################
$reports
$text

alerts: $reasons

alertlist: $alertlist
$alert


EoF

  $t=$id."_text1";
  if ($current{$t}=~/alert/i) {
       &my_alert;
  }
  if ($current{$t}=~/status/i) {
       &my_status;
  }


  &my_last;  # update job
  return();
 }


#############
 sub my_alert  {
##############
  # collect alerts

  my ($t,@to,$r,$pools,$w,@l,$l,$tmp,@w,$subject,$sl);

  $t=$id."_text1";
  $t=$current{$t};
  if (!($t=~/alert/i)) { return; }       # no alert

  #send only once a day
  $t=$id."_$alertlist";

  $t=~s/\s//gs;
  $t=~s/\_$//;
  $t.=".log";

  $t=~s/\s//gs;
  $sl="/var/web-gui/_log/report/alert.reported/$t";

  print "## check sendlog: $sl\n";

  if (-f "$sl") {  # sendlog?
       print "alert with log $t was already send today\n\n";
       return;
  }


  $t=$id."_to";
  my $to=$current{$t};

  #debug
  #&print_hash(%current);

  if ($reasons eq "") { return; }        # no alert

  my $host=&exe("hostname");
  chomp($host);

  $alert="Job $id $reasons\nAlertlist $alertlist\n\n$alert\n";
  $subject = "*** Storage Alert *** on $host\: ";                # Subject

  #write log
  open (PF, ">$sl");          # ex ex /tmp/nappit/job-scrub_1350378156.request
       flock(PF, LOCK_EX);
       print PF "run_$id $sys{'date'} $sys{'hour'}:$sys{'min'}\n$subject\n$alert";
  close (PF);

  # if not jets end today
  &my_prepare_send($to,$subject,$alert); # par subject, message

 }

 #############
 sub my_status  {
##############
    # collect status reports

    #sendlog
    my $sl="/var/web-gui/_log/report/status.reported/$id\.log";

    $t=$id."_text1";
    $t=$current{$t};
    if (!($t=~/status/i)) { return; }       # no status

    my $host=&exe("hostname");
    chomp($host);

    $subject="* Storage status report from $host";

    $t=$id."_trigger";
    my $reports=$current{$t};


    my $out=<<EoF;

Statusreport job $id from $host from $sys{'date'}  $sys{'hour'}:$sys{'min'}

################
Storage reports: $reports
################

$text
EoF

$t=$id."_to";
my $to=$current{$t};

#write log
  open (PF, ">$sl");          # ex ex /tmp/nappit/job-scrub_1350378156.request
       flock(PF, LOCK_EX);
       print PF "run_$id $sys{'date'} $sys{'hour'}:$sys{'min'}\n$subject\n$out";
  close (PF);

&my_prepare_send($to,$subject,$out); # par subject, message


#    # log status
#    if (-f "/var/web-gui/_log/tmp/mail-status.log") {
#         $text.="\n\n-user defined/ other job status:\n /var/web-gui/_log/tmp/mail-status.log\n\n";
#         $text.=`cat /var/web-gui/_log/tmp/mail-status.log`;
#         if (-f "/var/web-gui/_log/tmp/mail-status.last") { `rm /var/web-gui/_log/tmp/mail-status.last`; }
#         rename("/var/web-gui/_log/tmp/mail-status.log","/var/web-gui/_log/tmp/mail-status.last");
#    }

}  # end my_status


 ###########
 sub my_prepare_send {
 ############

  my ($t,$tls,$host,$send,$r);

  my $to=$_[0];                # allow commalist
  my $subject=$_[1];           # parameter as this is different from alert to status
  my $text   =$_[2];

  print "send job-report $subject\n";

  $t=$id."_send";
  $send=$current{$t};         # tls or basic

  $t=$id."_server";
  my $server=$current{$t};

  $t=$id."_from";
  my $from=$current{$t};

  $t=$id."_user";
  my $user=$current{$t};

  $t=$id."_pw";
  my $pw=$current{$t};

  #webapi
  if ($send=~/webapi/i) {
       # alert only!
       if ($subject=~/status report/) {
         $t=`hostname`; chomp($t);
         $subject="Report from $t";
         $text="use mail for status\nuse webapi for alert only";
       }


       $t=$id."_pushover-token";
       $current{'pushover-token'}=$current{$t};

       $t=$id."_pushover-user";
       $current{'pushover-user'}=$current{$t};

       $current{'subject'}=$subject;
       $current{'message'}=$text;

  }  else {

     #debug
     #  print "server,from,to,sub\n$server, $from, $to\n$subject\n ";

     if (!($server=~/\w+/))    { &my_err('please set a smtp-server in job - setup'); }
     if (!($to=~/\@/))         { &my_err('please set a mailto in job - setup'); }
     if (!($from=~/\@/))       { &my_err('please set a mailfrom in job - setup'); }

  }

  if ($send=~/webapi/i) {

     if (-f "/var/web-gui/_my/scripts/webapi/webapi.pl") {
        $current{'subject'}="my $current{'subject'}";
        require("/var/web-gui/_my/scripts/webapi/webapi.pl");                          # %current: token,to,subject,host,message
     } else {
        require("/var/web-gui/data/napp-it/zfsos/_lib/scripts/webapi.pl");             # %current: token,to,subject,host,message
     }
     print "492 webapi done: $current{'return'}\n";
     $info=$current{'return'};
     &my_log;
     exit;

  } else {
        #tls?
        if ($send=~/tls/i) {
            require("/var/web-gui/data/napp-it/zfsos/_lib/scripts/report/smtp-tls.lib");
        } else {
            require("/var/web-gui/data/napp-it/zfsos/_lib/scripts/report/smtp-p25.lib");
        }



        $t=$id."_to";
        my $to=$current{$t};                     # opt commalist a@xx.com,b@xx.com,c@xx.com
        my @to=split(/,/,$to);
        foreach my $to (@to) {
             print "## send job email 276 to $to\n";
             $r.=&my_send($server,$from,$to,$subject,$text,$user,$pw);        #server,from,to,sub,text,user,pw
        }
  }
  print "message was send .. \n$r";
  $info=$r;
  &my_log;

 }

############
sub my_err {
############
  $error="error";
  $info=$_[0];

  print "job-report my_err $info\n";

  &my_log;
  exit;
}

###########  ## log last run in jobfile /_log/jobs/id...job
sub my_log {
###########

  # print "job-repli 548 - call log id=$id action=$action\n";

  # line 1: lastrun = ok or err
  # line 2: time of last run
  # line 3+: info

  &task_gettime;                                             # $current{'timestamp'}, $current{'logtime'}

  my (@v,$v,$n,$l,$f1,$f2,@data);

  $l=$error;
  if ($l eq "") { $l="ok"; } else { $l="error"; $info="$info $error"; }

  $l=~s/\n/ /gs;
  $info=~s/\n.*//s;                                        # first line
  $info=~s/ +/ /g;

 #stage 1: log general jobs
 ###########################
  my $log="/var/web-gui/_log/jobs/jobs.log";
  my $lock="/var/web-gui/_log/jobs/jobs.lock";
  open (X,"<$lock");
  flock(X, LOCK_EX);
          open (F,"<$log");
              flock(F, LOCK_EX);
              @data=<F>;
          close (F);

        #unshift   $l=ok/error
        unshift(@data,"$l; report $ref $id; time: $current{'timestamp'}; info: $info\n");

        if (@data > 50) {
                   $t=@data-50;
                   splice(@data,50,$t);
        }

       $t=join("",@data);
       open (PF, ">$log");
          flock(PF, LOCK_EX);
          print PF "$t";
       close (PF);
 close (X);

 if ($info=~/^delete /) { exit; }


 #stage 2 update job.par  $current{'logtime'};
  $log="/var/web-gui/_log/jobs/$id.log";

  $t="$id"."_last";                                              # update last
  $current{$t}=$current{'logtime'};
  &task_update_par($id);                                         # update last


  # stage 3 id.log newest at top
  ###################
  &my_logid("$l","info: $info");

  # update .par
  &task_gettime;                                             # $current{'timestamp'}, $current{'logtime'}
  $t="$id"."_last";                                              # update last
  $current{$t}=$current{'logtime'};
  &task_update_par($id);

 exit;  # log always last action

}


##############  log to id.log
sub my_logid {
#############
my $err =$_[0];
my $data=$_[1];
$data=~s/ +/ /g;
my @data;
&task_gettime;

my $log="/var/web-gui/_log/jobs/$id.log";
  open (F,"<$log");
        flock(F, LOCK_EX);
        @data=<F>;
  close (F);

  #unshift   $l=ok/error
  unshift(@data,"$err; time: $current{'timestamp'}; $data\n");

  if (@data > 50) {
             $t=@data-50;
             splice(@data,50,$t);                 # delete from 50+
  }

 $t=join("",@data);
 open (PF, ">$log");
    flock(PF, LOCK_EX);
    print PF "$t";
 close (PF);


}



##
1;