#!"\xampp\perl\bin\perl.exe"

#monitor.pl

use strict;
use File::stat;
use Fcntl qw(:flock);                                        # filelocking

# auto-flush
$| = 1;

use vars qw(@f $client $ip $cmd $reply $t $tpath $wpath $dpath $p_zfsmin $p_zpoolmin);

#tmpfolder
$tpath="/xampp/web-gui/tmp";

#web-ui folder
$wpath="/xampp/web-gui";

#data folder
$dpath="/xampp/web-gui/data";

#lib, abs path
use lib "/xampp/web-gui/data/cs_server/CGI";

print "\ninitiate monitor service".`ver`."\n";

# is this windows?
my $dn = $^O;                                   # distribution from Perl ex MSWin32

# example for ps commands
#print `powershell.exe -command \"get-disk | select size\";`;

#read always
$p_zfsmin='sharesmb,sharenfs,name,type,creation,used,avail,refer,ratio,mounted,origin,quota,reservation,recordsize,mountpoint,compression,atime,rdonly,snapdir,aclmode,aclinherit,canmount,version,utf8only,normalization,case,nbmand,refquota,refreserv,guid,primarycache,secondarycache,dedup,sync,clones,encryption,keylocation,keyformat,pbkdf2iters,encroot,keystatus,special_small_blocks,driveletter';  # min zfs properties
$p_zpoolmin='name,size,cap,altroot,health,guid,version,autoreplace,failmode,autoexpand,dedup,free,allocated,frag,checkpoint,autotrim,readonly';

$t=&get_mydate;
&my_write("$spath/tmp/monitor.log","monitor started $t\n");

while (1) {
     # date and time
     #print "###############\nmonitor service $ver";
     #$t=time();
     #print ".$t\n";

     #activity, create basic .stat

     $last=&my_age();                           # how old is activity.log (updated by server.pl)
     $t=time();
     $last=$t=$last;
     # print "last activity: $last s\n";
     if (!($last > 60)) {
           sleep(10);
           next;
     }  # nothing to log

     # del old tmp files
     @f = glob("$tpath/*.tmp");
     foreach my $filename (@f) {
        if ($last > 60) { unlink($filename); }
     }
     @f = glob("$tpath/*.stat");
     foreach my $filename (@f) {
        if ($last > 60) { unlink($filename); }
     }

     # command.log und background.log
     @f = glob("$tpath/*.log");
     foreach my $filename (@f) {
        if ($last > 24*3600) { unlink($filename); }              # 24h
     }

     if ($dn=~/mswin/i) {
        #
        # disk.stat (same from get-disk)
        $t=`powershell -command "Get-PhysicalDisk | Select DeviceID,UniqueId,Manufacturer,Model,CanPool,OperationalStatus,HealthStatus,Serialnumber,size"`;
        &my_write("$tpath/disk.stat","$t");    # write disk.stat
        $t=~s/\n/ /gs;  $t=substr($t,0,60);
        print "write disk.stat: $t ..\n";

        #zfsmin
        $t=`powershell -command "zfs get -H $p_zfsmin`;
        &my_write("$tpath/zfsmin.stat","$t");    # write zfsmin.stat
        $t=~s/\n/ /gs;  $t=substr($t,0,60);
        print "write zfsmin.stat: $t ..\n";

        #poolmin
        $t=`powershell -command "zpool get -H $p_zpoolmin`;
        &my_write("zpoolmin.stat","$t");    # write zpoolmin.stat
        $t=~s/\n/ /gs;  $t=substr($t,0,60);
        print "zpoolmin.stat: $t ..\n";

     } else {           # all other X

     }

     sleep(10);          # intervall for new data
}

sub my_add {           # add ("path/filename","data",);  max 50 lines
##############

    my $file = $_[0];
    my $data = $_[1];
    my @old;

    ##########################
    my $lock="$spath/tmp/log.lock";
    open (X,"<$lock");
      flock(X, LOCK_EX);
          #
          open (F,"<$file");                      # old file
                flock(F, LOCK_EX);
                @old=<F>;
          close (F);

          if (@old > 100) {                       # max 100 lines
                     $t=@old-100;
                     splice(@old,100,$t);
          }

         $t=join("",@old);
         open (PF, ">$file");
            flock(PF, LOCK_EX);
            print PF "$t\n$data";                 # programm must add \n if needed to allow added strings
         close (PF);

    close (X);                                    # close lock


    #########################

    return();
}

sub my_write {           #   write ("path/filename","data",);
##############
    my $file = $_[0];
    my $data = $_[1];

    open(my $fh,">$file");
      flock($fh, LOCK_EX);
        print $fh "$data\n";
      flock($fh, LOCK_UN);
    close($fh);

    return();
}

sub my_read {           # read   read("path/filename");
##############
    my $file = $_[0];

    my $data="";
    my @data=();

    if (-f $file) {
        #
        open(my $fh, "<$file");
          flock($fh, LOCK_EX);
             @data = <$fh>;
          flock($fh, LOCK_UN);
        close($fh);
        $data=join("",@data);

    } else {
         $data="$file not found";
    }
    return($data);
}

############   fileage tempfile in s
sub my_age {
###########
    # any write or add updates tmpfolder/activity.log with a date() stamp.
    # to sync with monitor.pl
    # this sub reads activity.log and returns age in s

    my $file = "$spath/tmp/activity.log";
    if (!(-f $file)) { return "-1"; }        # file not found

    my $r=&my_read($file);  # last access
    $t=time();
    my $old=$t-$r;  # current - last in s

    return($old);
}


sub get_mydate {                # setzt datumsvariablen
###########
 my ($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime(time);
 $mon++;
 if ($sec < 10) { $sec = "0$sec"; }
 if ($min < 10) { $min = "0$min"; }
 if ($hour < 10) { $hour = "0$hour"; }
 if ($mday < 10) { $mday = "0$mday"; }
 if ($mon < 10) { $mon = "0$mon"; }
 $year=1900+$year;
 return("$year\.$mon\.$mday\.$hour\.$min\.$sec");
}




#1;